
#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
int steps=1; //globln promnn urujc poet krok
int max_steps=100; //rozsah AD pevodnku (0 a 255) se pepote na
//(0 a max_steps) krok motorku


void Move(int number_of_steps) {
//funkce Move provede zadan poet krok motorku smrem urenm znamnkem
int i;
int backward=0;
int init_gate_state;
if (number_of_steps<0) {
number_of_steps=-number_of_steps;
backward=1;
}
for(i=1;i<=number_of_steps;i++) {
init_gate_state=PTAD_PTAD6; //po.stav optobrny:
//0=brna otevena; 1=brna uzavena
while (PTAD_PTAD6==init_gate_state) { //dokud nedolo ke zmn stavu brny
PTAD_PTAD5=!backward; //spus oten vzad/vped
PTAD_PTAD4=backward;
}
PTAD_PTAD5=1; //zastav oten
PTAD_PTAD4=1;
}
}



interrupt 2 void IRQpin (void) {
//peruen od IRQ pinu
asm {
bset 2,IRQSC //IRQ acknowledge - potvrzen pjmu peruen
}
Move(-steps);
}


interrupt 23 void atdcoco (void) {
//peruen pi skonen AD pevodu (conversion complete)
steps=ATD1RH; //ten vsledku
steps=max_steps*steps/255+1; //vsledek AD pevodu se pepote na poet krok
ATD1SC=0b00000000; //nulovn pznaku peruen, povolen dalho pevodu
}


void main(void) {
int step_made=0;
/*** vypnut watchdog ***/
SOPT_COPE=0;//SOPT=System OPtions register, COPE=Watchdog Enable
/*** PORT PTA ***/
//ovld desku Evb Motor
PTAD=0b00111000;
PTADD=0b00111100;
/*** PORT PTD ***/
//zachytv stisk tlatka TL2
PTDPE_PTDPE3=1; //pullup enable na PTD3 - tlatko TL2
/*** PIN IRQ ***/
//zachytv stisk tlatka TL1
IRQSC_IRQPE=1; //povol IRQ pin (IRQ Pin Enable)
IRQSC_IRQEDG=0; //bude detekovat sestupnou hranu (IRQ Edge Select)
IRQSC_IRQIE=1; //povol peruen (IRQ Interrupt Enable)
/*** AD PEVODNK ***/
ATD1PE_ATDPE0=1; //ATD Pin Enable: povolen pinu 0 jako vstupu do AD
ATD1C_ATDPU=1; //ATD Power Up: zapne AD pevodnk
ATD1C_RES8=1; //ATD Result: vsledek pevodu bude 8bitov
ATD1SC=0b00000000; //ADT Status and Control: povolen pevodu a vbr kanlu 0
EnableInterrupts; //povolen peruen
for(;;) {
//nekonen smyka, zachytv se peruen od pinu IRQ a AD pevodnku
/*** OBSLUHA TLATKA TL2 ***/
if(!PTDD_PTDD3 && !step_made) { //stisk tlatka TL1 vyvol krok motorku
Move(steps); //motorek provede nastaven poet krok
step_made=1; //pznak, e motorek u provedl krok
}
if(PTDD_PTDD3) {
step_made=0; //po uvolnn tlatka TL2 se nuluje pznak provedenho kroku
}
}
}